﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel.Security;
using System.Web.Security;
using HLWebOKBAdminPlugin.OKBAdministrationService;
using HLWebOKBAdminPlugin.Helpers;

namespace HLWebOKBAdminPlugin.Models {
    public class AlgorithmClassModel {        

        public String SelectedSubMenu { get; set; }
        public IList<AlgorithmClass> AlgorithmClasses { get { return AlgorithmClassGetAll(); } }

        public AlgorithmClass AlgorithmClass { get; set; }

        //***************************************Algorithm Class********************************************
        //get all algorithm classes
        private IList<AlgorithmClass> AlgorithmClassGetAll() {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            IList<AlgorithmClass>  algorithmClassList = new List<AlgorithmClass>();

            if (adminClient != null) {
                AlgorithmClass[] algorithmClasses = adminClient.GetAlgorithmClasses();
                foreach (AlgorithmClass ac in algorithmClasses) {
                    algorithmClassList.Add(ac);

                }
            }//if (adminClient != null)

            return algorithmClassList;
        }//AlgorithmClassGetAll

        private long AddAlgorithmClass(AlgorithmClass algorithmClass) {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            if (adminClient != null) {
                return adminClient.AddAlgorithmClass(algorithmClass);
            }

            return 0;
        }//AddAlgorithmClass

        public void DeleteAlgorithmClass(long id) {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            if (adminClient != null) {
                adminClient.DeleteAlgorithmClass(id);
            }
        }//DeleteAlgorithmClass

        public long SaveAlgorithmClass(AlgorithmClass algorithmClass) {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            if (adminClient != null) {
                if (algorithmClass.Id == 0) {
                    return AddAlgorithmClass(algorithmClass);
                }
                else {
                    AlgorithmClass ac = adminClient.GetAlgorithmClass(algorithmClass.Id);

                    if (ac != null) {
                        adminClient.UpdateAlgorithmClass(algorithmClass);
                        return algorithmClass.Id;
                    }
                }
            }

            return 0;
        }//SaveAlgorithmClass               
    }
}